; KENWOOD DX-7030
;       
; If you're an owner of the KENWOOD DX-7030 you already will have 
; experienced that this model quite often fails to position to the
; desired index number. Expecially when accelerating to tape winding 
; speed (that is quite high with this model), index marks happen not to be
; recognized. This is the case when skipping to index one from the top of
; the tape. Our candidate then stopped at index two and aborted the index
; search without success.
; This 'bug' of KENWOOD not nessesarily means loss of data security 
; with the tripleDAT Streamer. If the computer doesn't receive the
; index header within a certain time (that is the timeout setting SECMAXWIND),
; the tape drive is directed to try again for GOTOIDXRETRY times.
; Targeting an index header may take somewhat longer than with other
; models, but in 99% the index will be found, finally.
; You may also help your KENWOOD manually before the software does so.
;
; Also the SLOW_FORWARD cueing operation worked somewhat strange,
; therefore also file targeting may take somewhat longer than with other
; models.
;
; Other KENWOOD 7030 unusual (to abnormal) habits:
; * the 7030 doesn't like recording from the very top of a tape
;     (so an initialization first skips some 5 seconds before recording)
; * the PLL (Phase Lock Loop) circuit (that is responsible to catch & generate
;     a steady frequency for the S/P-DIF carrier) is very slow. 
;     For that reason, we set the recording margins to the quite high  
;     value of 4 seconds to ensure a proper operation.  
; * this tape drive rewinds about two seconds when starting to record (!!?)
;
; Throughout our final tests, this configuration worked without any errors.
; If you're an owner of this model and have some experiences in
; storing data, we would be grateful to receive your comment about
; reliability....thanx.
;
;
I:kenw7030.cod

Q:PRE_FORMAT = STOP wait10 PLAY wait60 STOP.
Q:STARTUP_WRT =.
Q:STARTUP_RD =.
Q:START_REC = STOP seloutput wait10 REC wait40.
;Q:RESTART_REC = REC wait20.
;Q:PAUSE_REC = wait40 PAUSE.
Q:RESTART_REC = COPYON wait30.
Q:PAUSE_REC = wait40 COPYOFF.
Q:STOP_REC = wait50 STOP.
Q:STOP_PLAY = wait35 STOP.
Q:SET_INDEX = SIDWRT wait20.

;
; Timings for tape windings
; measured with the 7030
;
W:SFWRD = $0003 $0005 $0007 $0009 $000B $000D $000F $0012.
W:SBWRD = $0001 $0003 $0005 $0007 $0009 $000B $000D $000F.
W:FFWRD = $008A $0135 $01C9 $0252 $02ED $038A $041D $04b5.
W:FBWRD = $009F $012F $01D0 $020C $02F2 $0386 $0417 $04BE.

S:CHKCONNECTION = 0
S:WAITTOCONNECT = 20
S:RETRYRECONNECT = 5
S:STOPONSTARTUP = 1
S:PLAYIDXMODE = 0
S:USEFWIND = 1
S:TIMEBETWRCKEY = 30
S:TIMEBETWSAMERCKEY = 40
S:SETIDXMODE = 0
S:MINTIMEBETWIDX = 10
S:SECTOREW = 2
S:MINCONST4IDX = 256
S:REWTAPEONEXIT = 1
S:SECBEFOREIDX1 = 30
S:SECBEFWRTIDX = 3
S:GOTOIDXRETRY = 10
S:SECMAXWIND = 30
S:SECBEFREPLAY = 30
S:IR_REPEAT = 10
