; manual mode
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;       **  File: manual.ctl
;
;       **  Date: 30-Nov-1994
;
;       **  Demonstration file for the usage of remote control
;       **  play sequences.
;
;       **  with this file owner of DAT recorders without remote control
;       **  unit might be able to use the streamer.
;
;       **  for using this file with TSTORE, remove the DISP-statements
;       **  for sequences STARTUP_WRT and EXIT

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; fake some keys, that are neccassary for the streamer program
;
K:FFWRD = $01 $01 $FF $80 $00.
K:FBACK = $01 $01 $FF $80 $00.
S:IR_FREQ    = $19
S:IR_TMBASE0 = $6F
S:IR_TMBASE1 = $6F
S:IR_CONST1  = $0E

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; just display a message on startup for the user to get ready.
;
Q:STARTUP_WRT = DISP_STARTUP1 DISP_STARTUP2.
Q:STARTUP_RD  = STARTUP_WRT.

T:_STARTUP1 = Welcome to the manual mode of the triple DAT streamer!^J
T:_STARTUP2 =Have a nice trip !^J^J

; the text is displayed with the DISPxxx command, where xxx tells the
;  program which text to use.
; the ^J translates to a newline. it uses the rule, that everything after
;  a caret (^) is displayed as the character thats ASCII code is 64 less
;  then the given character. An exception is the sequence ^^, which results
;  in a single caret.
;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; PRE_FORMAT is called before actually starting a tape initialization.
;  it is used to skip a short part of the tape where the recorder might
;  not want to record any data.
; RESET_TAPE is the the sequence that is performed, if you press R when
;  asked to rewind the tape to the top of the tape.
; for manual mode, both are not required.
;
Q:PRE_FORMAT = .
Q:RESET_TAPE = .

;
; with START_REC the actuall recording begins. no index must be written
;  by this
;
Q:START_REC = SELOUTPUT COPYON DISP_STARTREC1 DISP_STARTREC2 WAIT0 DISP_STARTREC1d DISP_NL.

T:_STARTREC1 = *** Press REC. Ensure that the input signal is present, then start ^J
T:_STARTREC2 = *** recording by pressing REC+PLAY. Press any key when ready...
T:_STARTREC1d = done.^J
T:_NL = ^J

; SELOUTPUT is a command which forces the triple board to generate a output
;  signal that the recorder can detect.
; we have used the command WAITnn, where nn stands for an arbitrary
;  number of tenths of a second that the program has to wait without doing
;  anything else.
; a value of 0 means, that the program has to wait until the user has pressed
;  a key. specifying no number at all will do the same, but will also prompt
;  the user for a key.
;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; PAUSE_REC is called, when the program has to stop recording due to the
;  computer being too slow to fill buffers with data.
; we simply set copy prohibit bit with COPYOFF, so that the DAT recorder
;  switches to RECORD+PAUSE (after having insured that the data is on the
;  tape)
;

Q:PAUSE_REC = WAIT5 COPYOFF.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; RESTART_REC is issued, when buffers are filled again, and recording can
;  proceed. enabling copy simply switches the DAT recorder back to RECORD
;  mode, plus a small pause to let the mechanics inside the recorder to
;  do their job
;

Q:RESTART_REC = COPYON WAIT5.


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; when STOP_REC is called, recording must be stopped at this position.
;
Q:STOP_REC = DISP_STOPREC COPYOFF.

T:_STOPREC = Stop recording by pressing STOP!^J

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; while recording, we sometimes need to set an index.
;

Q:SET_INDEX = DISP_SETIDX WAIT0 DISP_SETIDXd.

T:_SETIDX = Set index ^@index now! ^GPress key when ready...
T:_SETIDXd = done.^J

; here we have used another exception to the caret rule. ^@index is replaced
;  by the current index number, no matter if it is set or seeked. if it is
;  used within a sequence except SET_INDEX and IDX_PLAY, its value is
;  undefined.
;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; that's all for the record part. now for the play part, we start with
;  START_PLAY. when listening to the tape we do not need the user to
;  tell us when he is ready, we find out by the data we receive from the
;  tape.

Q:START_PLAY = DISP_STARTPLAY.

T:_STARTPLAY = Press PlAY Now!^J

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; RESTART_PLAY is called when the program thinks the DAT player is not
;  playing at all even though it was told to. it might be displayed too
;  often, so leave it blank.

Q:RESTART_PLAY = .

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; IDX_PLAY is used to find the index where we expect our data. when this
;  sequence is complete, we assume the recorder to start playing at the
;  given index.

Q:IDX_PLAY = DISP_NL DISP_PLAYIDX.

T:_PLAYIDX = Start playing at index ^@index!^J

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; STOP_PLAY is what the name says.
;

Q:STOP_PLAY = DISP_NL DISP_STOPPLAY.

T:_STOPPLAY = Stop playing by pressing STOP!^J


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; when we have run too far somewhere, or we are looking for something
;  far away on the tape, give the user a chance to rewind.

Q:WIND_FWRD = DISP_NL DISP_WFWRD.
Q:WIND_BWRD = DISP_NL DISP_WBACK.

T:_WFWRD = Wind forward for ^@time seconds!^J
T:_WBACK = Wind backward for ^@time seconds!^J

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; the user shall decide himself what to at exit, so leave him relaxed.

Q:EXIT = DISP_EXIT.

T:_EXIT = ^JThat's all! Have a nice day.^J

;
; there is another sequence RECONNECT, but there too much internals involved,
;  so ignore it.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; some other settings useful for manual mode.
;

; fake winding, we simply need some values

W:SFWRD = $0004 $0040.
W:SBWRD = $0001 $0040.
W:FFWRD = $0007 $0040.
W:FBWRD = $000F $0040.

S:CHECKOUTPUT = 0
S:CHKCONNECTION = 0
S:STOPONSTARTUP = 0
S:USEFWIND = 0
S:SETIDXMODE = 0
S:MINTIMEBETWIDX = 9
S:SECTOREW = 0
S:REWTAPEONEXIT = 0
S:GOTOIDXRETRY = 5
S:SECBEFOREIDX1 = 30
